#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include "graphlib.h"

struct Line	{ int start,stop; };

struct Coord	{ double x,y,z; };

struct Pbuf	{ int x1,y,x2; };

typedef double Matrix[3][3];

int objanz;

struct Object { char name[81];
		int dots,lines;
		struct Coord 	*punkt;
		struct Line  	*line;

		struct Coord 	move,speed;
		Matrix 		orient,omega;
		int onoff;

		struct Pbuf 	*punktbuf;
		} *objekt,*objektlist;

struct Graphsize { int xs,ys,xb,yb; } grsize;

struct Coord nospeed={0,0,0};
struct Projdata 
	{
	  double ddy,eye;
	} proj = {-2000.0,-100.0 };

int active_screen=0;
int blinking=1;

const double grow  =  1.02;
const double shrink=1/1.02;

void matrix1(Matrix mat)
{ int x,y;
  for(x=0;x<3;x++)
   for(y=0;y<3;y++)
   {mat[x][y]= (x==y&&x<3) ? 1 : 0;}}

void matrimult(Matrix matrix,Matrix operand)
{ int x,y,z;
  static Matrix source;
  memcpy(source,matrix,sizeof(Matrix));
  for(x=0;x<3;x++)
    for(y=0;y<3;y++)
    { matrix[x][y]=0.0;
      for(z=0;z<3;z++) 
        matrix[x][y]+=source[x][z]*operand[z][y];
    }
}

void do_resize(struct Object *obj,double factor,int x,int y,int z)
{
	Matrix hlp2;

	matrix1(hlp2);
    	hlp2[0][0]= x ? factor : 1.0;
    	hlp2[1][1]= y ? factor : 1.0;
    	hlp2[2][2]= z ? factor : 1.0;
	matrimult(obj->orient,hlp2);
}

void inputobject(struct Object *obj,FILE *in)
{ int x,dim;
  struct Coord *help;
  struct Line *h;
  FILE *out;

  puts("  D i m e n s i o n - X    (c) by H. & A. Beck Individualsoftware 25/02/1991");
  puts("");

  out=NULL;

  fscanf(in,"%s",obj->name);
  if (out) fprintf(out,"%s\n",obj->name);
  
  obj->move.x=obj->move.y=obj->move.z=0;
  obj->speed.x=obj->speed.y=obj->speed.z=0;
  obj->onoff=1;
  matrix1(obj->orient);
  matrix1(obj->omega);

  fscanf(in,"%d",&dim);
  if (out) fprintf(out,"%d\n",dim);
  if (dim!=3) exit(1);

  fscanf(in,"%d",&obj->dots);
  if (out) fprintf(out,"%d\n",obj->dots);

  fscanf(in,"%d",&obj->lines);
  if (out) fprintf(out,"%d\n",obj->lines);

  if ((obj->punkt=malloc(obj->dots *sizeof(struct Coord)))==0) exit(0);
  if ((obj->line =malloc(obj->lines*sizeof(struct Line )))==0) exit(0);

  if ((obj->punktbuf=malloc(obj->lines*sizeof(struct Pbuf)))==0) exit(0);
  memset(obj->punktbuf,0,obj->lines*sizeof(struct Pbuf));

  help=obj->punkt;h=obj->line;

  for(x=0;x<obj->dots;x++)
  { 
    fscanf (in,"%lf", &help->x);
    if (out) fprintf(out,"%f\n",help->x);

    fscanf (in,"%lf", &help->y);
    if (out) fprintf(out,"%f\n",help->y);

    fscanf (in,"%lf", &help->z);
    if (out) fprintf(out,"%f\n",help->z);

    help++;
  }

  for(x=0;x<obj->lines;x++)
  {
    fscanf(in,"%d",&h->start);
    if (out) fprintf(out,"%d\n",h->start);

    fscanf(in,"%d",&h->stop );
    if (out) fprintf(out,"%d\n",h->stop );

    h++;
  }

  if (out) fclose(out);
}

void transform2(struct Object *obj)
{ int count,flags;
  double hilfe,se,ed;
  struct Coord *h;
    
  struct Pbuf *p;
  
  flags=0;
  for(count=0,h=obj->punkt,p=obj->punktbuf;count<obj->dots;count++,h++,p++)
  {
	hilfe=h->x*obj->orient[2][0]+h->y*obj->orient[2][1]+h->z*obj->orient[2][2];
	se=proj.ddy/(hilfe+obj->move.z-proj.ddy);
	ed=se*proj.eye+proj.eye;

	hilfe=h->x*obj->orient[0][0]+h->y*obj->orient[0][1]+h->z*obj->orient[0][2];
	p->x2=(p->x1=grsize.xb+ed+(obj->move.x-hilfe)*se)-ed-ed;

	hilfe=h->x*obj->orient[1][0]+h->y*obj->orient[1][1]+h->z*obj->orient[1][2];
	p->y=grsize.yb+(obj->move.y+hilfe)*se;

	if (p->y<          0) flags|=1;
	if (p->y>2*grsize.ys) flags|=2;
	if (p->x1<         0||p->x2<         0) flags|=4;
	if (p->x1>grsize.xs ||p->x2>grsize.xs ) flags|=8;
  }
  switch(flags&3)
  {case 1:if (obj->speed.y>0) obj->speed.y=-obj->speed.y;break;
   case 2:if (obj->speed.y<0) obj->speed.y=-obj->speed.y;break;
   case 3:do_resize(obj,shrink,1,1,1);break;
  }
  switch(flags&12)
  {case 4:if (obj->speed.x>0) obj->speed.x=-obj->speed.x;break;
   case 8:if (obj->speed.x<0) obj->speed.x=-obj->speed.x;break;
   case 12:do_resize(obj,shrink,1,1,1);break;

  }
  if (obj->move.z>    0&&obj->speed.z>0) obj->speed.z=-obj->speed.z;
  if (obj->move.z<-1000&&obj->speed.z<0) obj->speed.z=-obj->speed.z;
}


void draw(struct Object *obj,int colbase)
{int count;
 struct Pbuf *p,*p2;
 struct Line *lb;

 if (obj->onoff==0) return;

 grsize.yb=active_screen*grsize.ys+grsize.ys/2;

 matrimult(obj->orient,obj->omega);
 obj->move.x+=obj->speed.x;
 obj->move.y+=obj->speed.y;
 obj->move.z+=obj->speed.z;
 transform2(obj);
 /*setdrawmode(OR);*/

 ggi_setcolor(colbase+1);
 for(count=0,lb=obj->line;count<obj->lines;count++,lb++)
 { p =(obj->punktbuf+lb->start);
   p2=(obj->punktbuf+lb->stop);
   ggi_drawline( p->x1,p->y,p2->x1,p2->y);
 }
  
 ggi_setcolor(colbase+2);
 for(count=0,lb=obj->line;count<obj->lines;count++,lb++)
  {p =(obj->punktbuf+lb->start);
   p2=(obj->punktbuf+lb->stop);
   ggi_drawline( p->x2,p->y,p2->x2,p2->y); }
}


void waitbuttchg(int x)
{ 
#if 0
do {rp.r_ax=3;intr(0x33,&rp);}while((rp.r_bx&7)==(x&7));
#endif
}

void graph_setup(void)
{ 
  struct ggi_color aktregs[256];

  ggi_graphmode(800,600,800,1200,GT_8BIT);

  ggi_getpalvec(0,256,aktregs);
  aktregs[0].r=  0;aktregs[0].g=  0;aktregs[0].b= 0;
  aktregs[1].r=254;aktregs[1].g=  0;aktregs[1].b= 0;
  aktregs[2].r=  0;aktregs[2].g=199;aktregs[2].b= 0;
  aktregs[3].r=254;aktregs[3].g=199;aktregs[3].b= 0;
  aktregs[4].r=  0;aktregs[4].g=  0;aktregs[4].b= 0;
  aktregs[5].r=138;aktregs[5].g=  0;aktregs[5].b= 0;
  aktregs[6].r=  0;aktregs[6].g=108;aktregs[6].b= 0;
  aktregs[7].r=138;aktregs[7].g=108;aktregs[7].b= 0;
  ggi_setpalvec(0,256,aktregs);

  grsize.xb=(grsize.xs=CurrentMode.visible.x)/2;
  grsize.yb=(grsize.ys=CurrentMode.visible.y)/2;
}

void drawall(void)
{ int x;
  static cnt=0;
  active_screen^=1;
  ggi_setcolor(0);
  ggi_drawbox(0,active_screen*grsize.ys,grsize.xs,grsize.ys);
  if (blinking) 
  { cnt++;
    for(x=0;x<objanz;x++) 
      draw(objektlist+x,((cnt&8)&&objektlist+x==objekt)*4);
  } else
  { for(x=0;x<objanz;x++) draw(objektlist+x,0); }
  ggi_waitvretrace();
  ggi_setviswin(0,active_screen*CurrentMode.visible.y);
}

void do_turn(int tx,int ty)
{	
	Matrix hlp2;
	const double sphi=sin(M_PI/1600);
	const double cphi=cos(M_PI/1600);
	
	matrix1(hlp2);
	hlp2[tx][tx]= cphi;hlp2[ty][tx]= sphi;
	hlp2[tx][ty]=-sphi;hlp2[ty][ty]= cphi;
	matrimult(objekt->omega,hlp2);
}

void read_state(char *nam)
{ int hand,x;
  struct Object *op=objektlist;

  if ((hand=open(nam,O_RDONLY))==-1) return;

  read(hand,&x,sizeof(x));
  if (x>objanz) x=objanz;

  while(x--)
  { read(hand,&op->move ,sizeof(op->move  ));
    read(hand,&op->speed,sizeof(op->speed ));
    read(hand,&op->onoff,sizeof(op->onoff ));
    read(hand,op->orient,sizeof(op->orient));
    read(hand,op->omega ,sizeof(op->omega ));
    op++;
  }
  close(hand);
}

void write_state(char *nam)
{ int hand,x;
  struct Object *op=objektlist;

  if ((hand=open(nam,O_WRONLY|O_CREAT|O_TRUNC,0644))==-1) return;

  write(hand,&objanz,sizeof(objanz));
  x=objanz;

  while(x--)
  { write(hand,&op->move ,sizeof(op->move  ));
    write(hand,&op->speed,sizeof(op->speed ));
    write(hand,&op->onoff,sizeof(op->onoff ));
    write(hand,op->orient,sizeof(op->orient));
    write(hand,op->omega ,sizeof(op->omega ));
    op++;
  }
  close(hand);
}

void main(int argn,char *argv[])
{ int x;
  FILE *in;
  
  char statename[256]="default.st";

  
  enum Mode { M_TURN,M_MOVE,M_VELO,M_SIZE } mode=M_TURN;


  ggi_init();

  if (argn>=2)
  {	objanz=argn-1;
	if ((objektlist=malloc(objanz*sizeof(struct Object)))==NULL) exit(1);

	for(x=0;x<objanz;x++)
	{	if ((in=fopen(argv[1+x],"r"))==0)
		{	puts("Unable to open file !");exit(1);
		}
	 	inputobject(objektlist+x,in);
		fclose(in);
	}
  }
  else 
  {	puts("usage: dix3 objects");exit(1);
  }

  objekt=objektlist;
  read_state(statename);	/* Read the default state */

  graph_setup();

  drawall();x=-1;

#if 0
  gotoxy(1,1);puts("                              ");
  rp.r_ax=0;intr(0x33,&rp);rp.r_ax=2;intr(0x33,&rp);
  rp.r_ax=7;rp.r_cx=0000;rp.r_dx=16000;intr(0x33,&rp);
  rp.r_ax=8;rp.r_cx=0000;rp.r_dx=16000;intr(0x33,&rp);
  rp.r_ax=4;rp.r_cx=8000;rp.r_dx= 8000;intr(0x33,&rp);
  rp.r_ax=0xf;rp.r_cx= 1;rp.r_dx=    1;intr(0x33,&rp);
#endif
  do
  {
  	if (ggi_kbhit()) {x=ggi_getch();}
#if 0
   rp.r_ax=3;intr(0x33,&rp);
   if ((rp.r_bx&7)==7||x==27) break;
   if (rp.r_bx&4) x='t';
   if (rp.r_bx&2) x='T';
   if ((rp.r_bx&6)==6) x='0';
   if ((rp.r_bx&1)&&active_screen==0)
		  {do{rp.r_ax=3;intr(0x33,&rp);
		      if (rp.r_bx&4) {tx++;tx%=3;}
		      if (rp.r_bx&2) {ty++;ty%=3;}
		      gotoxy(1,1);printf("%d - %d",tx,ty);waitbuttchg(rp.r_bx);
		     }while(rp.r_bx&1);
		     rp.r_ax=4;rp.r_cx=-8*m[tx]+8000;rp.r_dx=-8*m[ty]+8000;
		     gotoxy(1,1);puts("                              ");
		     intr(0x33,&rp);goto recen;}
   m[tx]+=1000-(rp.r_cx>>3);m[tx]/=2;
   m[ty]+=1000-(rp.r_dx>>3);m[ty]/=2;
#endif

	drawall();

	if(x==-1) continue;

	switch(x)
	{ 
	  case 't':
	  case 'T':mode=M_TURN;break;
	  case 'm':
	  case 'M':mode=M_MOVE;break;
	  case 's':
	  case 'S':mode=M_SIZE;break;
	  case 'v':
	  case 'V':mode=M_VELO;break;
	  
	  case 'b':
	  case 'B':blinking=!blinking;break;	/* Stop the blinking */

	  case 'o':
	  case 'O':objekt->onoff^=1;break;

	  case 'x':switch(mode)
	  	   { case M_TURN:do_turn(1,2);break;
	  	     case M_MOVE:objekt->move.x+=10;break;
	  	     case M_VELO:objekt->speed.x++;break;
	  	     case M_SIZE:do_resize(objekt,grow  ,1,0,0);break;
	  	   }
	  	   break;
	  case 'X':switch(mode)
	  	   { case M_TURN:do_turn(2,1);break;
	  	     case M_MOVE:objekt->move.x-=10;break;
	  	     case M_VELO:objekt->speed.x--;break;
	  	     case M_SIZE:do_resize(objekt,shrink,1,0,0);break;
	  	   }
	  	   break;
	  case 'y':switch(mode)
	  	   { case M_TURN:do_turn(0,2);break;
	  	     case M_MOVE:objekt->move.y+=10;break;
	  	     case M_VELO:objekt->speed.y++;break;
	  	     case M_SIZE:do_resize(objekt,grow  ,0,1,0);break;
	  	   }
	  	   break;
	  case 'Y':switch(mode)
	  	   { case M_TURN:do_turn(2,0);break;
	  	     case M_MOVE:objekt->move.y-=10;break;
	  	     case M_VELO:objekt->speed.y--;break;
	  	     case M_SIZE:do_resize(objekt,shrink,0,1,0);break;
	  	   }
	  	   break;
	  case 'z':switch(mode)
	  	   { case M_TURN:do_turn(0,1);break;
	  	     case M_MOVE:objekt->move.z+=10;break;
	  	     case M_VELO:objekt->speed.z++;break;
	  	     case M_SIZE:do_resize(objekt,grow  ,0,0,1);break;
	  	   }
	  	   break;
	  case 'Z':switch(mode)
	  	   { case M_TURN:do_turn(1,0);break;
	  	     case M_MOVE:objekt->move.z-=10;break;
	  	     case M_VELO:objekt->speed.z--;break;
	  	     case M_SIZE:do_resize(objekt,shrink,0,0,1);break;
	  	   }
	  	   break;

	  case 'a':switch(mode)
	  	   { case M_TURN:do_turn(0,1);do_turn(0,2);do_turn(1,2);break;
	  	     case M_MOVE:objekt->move.x+=10;objekt->move.y+=10;
	  	     		 objekt->move.z+=10;break;
	  	     case M_VELO:objekt->speed.z++;objekt->speed.y++;objekt->speed.x++;break;
	  	     case M_SIZE:grow:
	  	     		 do_resize(objekt,grow  ,1,1,1);break;
	  	   }
	  	   break;

	  case 'A':switch(mode)
	  	   { case M_TURN:do_turn(2,1);do_turn(2,0);do_turn(1,0);break;
	  	     case M_MOVE:objekt->move.x-=10;objekt->move.y-=10;
	  	     		 objekt->move.z-=10;break;
	  	     case M_VELO:objekt->speed.z--;objekt->speed.y--;objekt->speed.x--;break;
	  	     case M_SIZE:shrink:
	  	     		 do_resize(objekt,shrink,1,1,1);break;
	  	   }
	  	   break;

	  case '0':matrix1(objekt->omega );objekt->speed=nospeed;break;
	  case '=':matrix1(objekt->orient);break;
	  
	  case '>':goto grow;
	  case '<':goto shrink;

	  case '+':if (objekt<objektlist+objanz-1) objekt++;break;
	  case '-':if (objekt>objektlist         ) objekt--;break;
	  
	  case 'w':
	  case 'W':if (scanf("%s",statename)==1) strcat(statename,".st");
	  	   write_state(statename);
	  	   break;
	  case 'r':
	  case 'R':if (scanf("%s",statename)==1) strcat(statename,".st");
	  	   read_state(statename);
	  	   break;
	}
	
	if (x==27) break;
	else x=-1;

  } while(x!=27);

  ggi_exit();
}
