#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <linux/vt.h>
#include <string.h>
#include "graphlib.h"

struct ggi_color pal[256];

int main(void)
{ int t,x,c,y;
  int sx[]={1024,640,640,800,640,640,640,320,320,320,160};
  int sy[]={ 768,400,480,600,200,100, 50,240,200,100,120};

  ggi_init();
         
  for(t=0;t<sizeof(sx)/sizeof(int);t++)
  {
    if (ggi_graphmode(sx[t],sy[t],sx[t],sy[t],GT_32BIT)) continue;

#if 0
    /* See if Gamma correction works.*/
    for(c=0;c<256;c++)
    { pal[c].r=c&127;pal[c].g=c&127;pal[c].b=c&127; }
    ggi_setpalvec(0,256,pal);
#endif

    ggi_setcolor(0);
    ggi_fillscreen();

    for(x=0;x<256;x++)
    { ggi_setcolor(x);
      for(y=0;y<50;y++)
        ggi_drawpixel(x,y);
    }
    for(x=0;x<256;x++)
    { ggi_setcolor(x<<8);
      for(y=50;y<100;y++)
        ggi_drawpixel(x,y);
    }
    for(x=0;x<256;x++)
    { ggi_setcolor(x<<16);
      for(y=100;y<150;y++)
        ggi_drawpixel(x,y);
    }
    for(x=0;x<256;x++)
    { ggi_setcolor(x*0x010101);
      for(y=150;y<200;y++)
        ggi_drawpixel(x,y);
    }
    ggi_getch();

    for(c=1;c<24;c++)
    { ggi_setcolor(1<<c);
      for(y=0;y<200;y++)
       for(x=0;x<320;x++)
       ggi_drawpixel(x,y);
    }
    ggi_setcolor(0xffffff);
    ggi_printf(0,200,"This is a small test %x !",0xab);

    for(c=0;c<=256;c++)
    { for(y=255;y>=0;y--)
      { ggi_setcolor(c+(y<<8));
        ggi_drawline(0,0,255,y);
        ggi_drawline(0,0,y,255); }
    }

    
#if 0 || CHECK_DEADLOCK_CONDITION
    *((int *)(ggi_membuffer+0xffff))=0x1234;
#endif
    
    for(c=0;c<16;c++)
    { ggi_setcolor(c*0x010101);
      for(x=0;x<320;x++)
       for(y=0;y<200;y++)
        ggi_drawpixel(x,y&63);
    }
    for(c=0;c<16;c++)
    { ggi_setcolor(c*0x000101);
      for(y=0;y<200;y++)
        ggi_drawhline(0,y,320);
    }
    for(c=0;c<255;c++)
    { ggi_setcolor(c*0x010001);ggi_drawbox(0,0,sx[t],sy[t]); }
    
    for(c=0;c<16;c++)
    { ggi_setcolor(1<<c);ggi_fillscreen(); }
    for(c=0;c<256;c+=8)
    { ggi_setcolor(c*0x010001);ggi_drawcircle(c+100,c+100,c); }
    for(c=0;c<256;c+=8)
    { ggi_setcolor(c*0x010100);ggi_drawcircle(356-c,c+300,256-c); }

    ggi_getch();
  }
  ggi_exit();
  return(0);
}
