/*\
|*| --------------------------------------------------------------------------
|*|	generic CLUT manipulations
|*| --------------------------------------------------------------------------
|*|
|*|	Copyright (C) 1995, The SCRDRV project.
|*|
|*|	This program is free software; you can redistribute it and/or modify
|*|	it under the terms of the GNU General Public License as published by
|*|	the Free Software Foundation; either version 2, or (at your option)
|*|	any later version.
|*|
|*|	This program is distributed in the hope that it will be useful,
|*|	but WITHOUT ANY WARRANTY; without even the implied warranty of
|*|	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|*|	GNU General Public License for more details.
|*|
|*|	You should have received a copy of the GNU General Public License
|*|	along with this program; see the file COPYING.  If not, write to
|*|	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|*|
|*| ---------------------------------------------------------------------------
\*/

static void
set_CLUT_entry(struct ggi_color *color, unsigned char index)
{
  outbDAC(index, DAC_PW_INDEX);
  outsbDAC(DAC_P_DATA, color, 3);
}

static void
get_CLUT_entry(struct ggi_color *color, unsigned char index)
{
  outbDAC(index, DAC_PR_INDEX);
  insbDAC(DAC_P_DATA, color, 3);
}

static void
set_CLUT_entries(struct ggi_color *table, unsigned char index, int len)
 {
    outbDAC(index, DAC_PW_INDEX);
    len += len + len;
    outsbDAC(DAC_P_DATA, table, len);
 }

static void
get_CLUT_entries(struct ggi_color *table, unsigned char index, int len)
 {
    outbDAC(index, DAC_PR_INDEX);
    len += len + len;
    insbDAC(DAC_P_DATA, table, len);
 }

