/*\
|*| --------------------------------------------------------------------------
|*|     GGI general definitons, structures, etc.
|*| --------------------------------------------------------------------------
|*|
|*|	Copyright (C) 1995 by Andreas Beck [becka@hp.rz.uni-duesseldorf.de]
|*|			  and Steffen Seeger [seeger@physik.tu-chemnitz.de]
|*|
|*|	This program is free software; you can redistribute it and/or modify
|*|	it under the terms of the GNU General Public License as published by
|*|	the Free Software Foundation; either version 2, or (at your option)
|*|	any later version.
|*|
|*|	This program is distributed in the hope that it will be useful,
|*|	but WITHOUT ANY WARRANTY; without even the implied warranty of
|*|	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|*|	GNU General Public License for more details.
|*|
|*|	You should have received a copy of the GNU General Public License
|*|	along with this program; see the file COPYING.  If not, write to
|*|	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|*|
|*| ---------------------------------------------------------------------------
\*/

#ifndef	_ggi_h
#define	_ggi_h

#define	TRUE	1
#define	FALSE	0

#define	GGIVERSION	001

	struct	ggi_range { int min, max; };
	struct	ggi_ratio { int mul, div; };
	struct	ggi_coord { int   x,   y; };
	struct	ggi_color { unsigned char r,g,b; };
	struct	ggi_drawinfo {	int fg_color;
				int bg_color;
				int drawmode; };
	struct 	ggi_cursorinfo {int     col1,col2;
				int     sx,sy;
				int     hotx,hoty;
				char    *color,*shape; };

	enum ggi_graphtype
	{	GT_TEXT	 =  0,		/* alphanumeric modes		*/
		GT_1BIT	 =  1,		/*  1 bpp graphics		*/
		GT_4BIT_PLANES	 =  2,	/*  4 bpp graphics		*/
		GT_8BIT	 =  3,		/*  8 bpp graphics		*/
		GT_15BIT =  4,		/* 15 bpp graphics 		*/
		GT_16BIT =  5,		/* 16 bpp graphics		*/
		GT_24BIT =  6,		/* 24 bpp graphics		*/
		GT_32BIT =  7,		/* 24 bpp word aligned  	*/
		GT_LAST  =  8		/* last mode assigned   	*/
	};

	enum ggi_trflags
	{      TRF_NO_ACCEL    =  1 };  /* What more ? */

	struct ggi_mode_request	/* requested by user and changed by driver */
	{
	  struct ggi_coord	visible;	/* vis. pixels, not changed   */
          struct ggi_coord	virtual;	/* virt. pixels, may change   */
	  enum ggi_graphtype	graphtype;	/* which mode ?		      */
	  struct ggi_coord	textgrid;	/* fontsize 		      */
	  enum ggi_trflags	trflags;	/* special flags	      */
#if 0
	  struct ggi_coord	size;		/* size of visible in mm      */
	  unsigned short	pages;		/* min. # of graphics pages   */
	  unsigned short	page0y;		/* size of graphics page 0    */
#endif
	};


	enum PowerSave  { PWR_ON=0,PWR_STANDBY,PWR_SUSPEND,PWR_OFF };

#endif	/* #ifdef _ggi_h */
