/*\
|*| ---------------------------------------------------------------------------
|*|
|*| ---------------------------------------------------------------------------
|*|
|*|	Copyright (C) 1995 by The SCRDRV Project
|*|
|*|	This program is free software; you can redistribute it and/or modify
|*|	it under the terms of the GNU General Public License as published by
|*|	the Free Software Foundation; either version 2, or (at your option)
|*|	any later version.
|*|
|*|	This program is distributed in the hope that it will be useful,
|*|	but WITHOUT ANY WARRANTY; without even the implied warranty of
|*|	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|*|	GNU General Public License for more details.
|*|
|*|	You should have received a copy of the GNU General Public License
|*|	along with this program; see the file COPYING.  If not, write to
|*|	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|*|
|*| ---------------------------------------------------------------------------
\*/

#include <linux/kernel.h>

#include "graphdev.h"
#include "kgi.h"

#define MON_VERSION "0.00 ALPHA"

#if !((MONITORVERSION == 01) || (MODEVERSION == 01))
 #warning	data structres have changed, check this code !
#endif

#ifdef DEBUG
static char *DISPTYPES[LAST_DISPTYPE]=
{ "EGA-8","EGA-16","VGA","PLASMA","TFT","LCD" };
#endif

static struct kgi_monitor
monitor = {
		"Nowhere Incorporated",	/* manufacturer		*/
		"Nothing",		/* model		*/
		GM_ALL,			/* supported modes	*/
		0,			/* special capabilities	*/
		{ 1024, 768 },		/* maximum resolution	*/

		{  382, 242 },		/* max. picture size	*/
		VGA | COLOR,		/* VGA color monitor	*/
		SYNC_NORMAL,		/* normal syncing, VESA	*/
		{     0,  50000000 },	/* pixel clock range	*/
		{ 28000,     31000 },	/* hfreq range		*/
		{   55,         75 }	/* vfreq range		*/
	   };

/*\
|*|	GGI interface
\*/

int
kgi_monitor_init(void)
{
   TRACE(printk("%s %s Monitor Driver v"MON_VERSION"\n", \
         monitor.manufact, monitor.model));
   TRACE(printk("(%s - %s, %dx%d Pixel, %d mm x %d mm, %d-%d kHz, %d-%d Hz)\n",\
	  DISPTYPES[monitor.disptype & ~MONO],\
	  (monitor.disptype & MONO) ? "monochrome" : "color",\
	  monitor.maxdots.x,\
	  monitor.maxdots.y,\
	  monitor.size.x,\
	  monitor.size.y,\
	  monitor.hfreq.min/1000 ,monitor.hfreq.max/1000,\
	  monitor.vfreq.min      ,monitor.vfreq.max ));
   return TRUE;
}

void
kgi_monitor_done(void)
{
   TRACE(printk("%s %s Monitor driver removed.\n", \
         monitor.manufact, monitor.model));
}

struct kgi_monitor
*kgi_monitor_get_info (void)
{
  return &monitor;
}

int
kgi_monitor_check_mode (struct kgi_mode *mode, enum kgi_tm_cmd cmd)
{ 
  #warning	write your code here !!
}

int
kgi_monitor_set_mode(struct kgi_mode *mode)
{ 
   return EOK;
}

int
kgi_monitor_ioctl (struct inode *inode, struct file *file, unsigned int cmd,
		  unsigned long arg)
{
  return EMONITOR;
}
