/* 
   Monitor-driver generic functions

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <linux/config.h>
#include <linux/module.h>
#include <linux/version.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/mm.h>
#include <linux/fs.h>
#include <linux/malloc.h>
#include <linux/fcntl.h>
#include <linux/vt.h>
#include <sys/ioctl.h>
#include <asm/io.h>
#include <asm/pgtable.h>
#include "graphdev.h"
#include "kgi.h"
#include "monitor/monitor_generic.h"

/* List of possible timings */
struct kgi_mode TMlist[MAXPREFMODES];
int TMnum=0;

extern struct kgi_monitor mon_par;

int mon_getinfo(void)
{ int i;
  if ((i=verify_area(VERIFY_WRITE, *(void **) parameters, sizeof(struct kgi_monitor))))
    return(i);
  memcpy_tofs  (*(void **) parameters,&mon_par , sizeof(struct kgi_monitor));
  return(0);
}

int mon_setinfo(void)
{ int i;
  if ((i=verify_area(VERIFY_READ, *(void **) parameters, sizeof(struct kgi_monitor))))
    return(i);
  memcpy_fromfs  (&mon_par,*(void **) parameters, sizeof(struct kgi_monitor));
  return(0);
}

int mon_setprefmode(void)
{ int i;
  if (TMnum >= MAXPREFMODES) return(-ENOSPC);	/* Table is full */
  if ((i=verify_area(VERIFY_READ, *(void **) parameters, sizeof(struct kgi_mode))))
    return(i);
  memcpy_fromfs  (&TMlist[TMnum++],*(void **) parameters, sizeof(struct kgi_mode));
  return(0);
}

int mon_getprefmode(void)
{ int i,num;
  num=*(int *)parameters;
  if (num<0 || num>=TMnum) return(-EIO);	/* No such entry */
  if ((i=verify_area(VERIFY_WRITE, *((void **)parameters+1), sizeof(struct ggi_mode_request))))
    return(i);
  memcpy_tofs  (*((void **)parameters+1),&TMlist[num].request, sizeof(struct ggi_mode_request));
  return(0);
}

int mon_vesa_pwr(void)
{ int i;
  if (!(mon_par.synctype&POWER_SAVE)) return(-EIO);
  i=*(int *)parameters;
  return(vesa_pwrsave(i));
}