/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define _LIB_COMPILE_

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include <string.h>
#include "../include/graphlib.h"


/**********************/
/* draw/get/put a box */
/**********************/
static int drawbox_lower(int unused,void *xywl)
{ 
	struct { int x,y,width,len;	} 	*par;

	par=xywl;

	while(par->len--)
		ggi_drawhline(par->x,par->y++,par->width);
	return(0);
}  

int ggi_drawbox(int x,int y,int width,int length)
{
	switchavail(IO_GRAPH_DRAWBOX,&x);
	setdoemu(IO_GRAPH_DRAWBOX,AVE_ALWAYS,drawbox_lower,&x);
}

static int getbox_lower(int unused,void *xywl)
{ 
	struct { int x,y,width,len;
		 char *buffer; 	} 	*par;

	par=xywl;

	while(par->len--)
	{	ggi_gethline(par->x,par->y++,par->width,par->buffer);
		par->buffer+=par->width; 
	}
	return(0);
}

int ggi_getbox(int x,int y,int width,int length,void *buffer)
{
	switchavail(IO_GRAPH_GETBOX,&x);
	setdoemu(IO_GRAPH_GETBOX,AVE_ALWAYS,getbox_lower,&x);
}

static int putbox_lower(int unused,void *xywl)
{ 
	struct p { int x,y,width,len;
		 char *buffer; 	} 	*par;

	par=xywl;

	while(par->len--)
	{	ggi_puthline(par->x,par->y++,par->width,par->buffer);
		par->buffer+=par->width; 
	}
	return(0);
}

int ggi_putbox(int x,int y,int width,int length,void *buffer)
{
	switchavail(IO_GRAPH_PUTBOX,&x);
	setdoemu(IO_GRAPH_PUTBOX,AVE_ALWAYS,putbox_lower,&x);
}
