/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define _LIB_COMPILE_

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include <string.h>
#include "../include/graphlib.h"


/****************************************/
/* draw a circle - highly optimized ;-) */
/****************************************/
static int drawcircle_lower(int unused,void *xyr)
{	
	struct { int xc,yc,rad;} *par;
	int x,y,od,md,sd;

	par=xyr;

	x=par->rad;y=md=0;
	while(x>=y)
	{ ggi_drawpixel(par->xc-y,par->yc-x);ggi_drawpixel(par->xc+y,par->yc-x);
	  od=md+y+y+1;sd=od-x-x-1;y++;md=od;
	  if (abs(sd)<abs(od)) {x--;md=sd;}
	}
	x=par->rad;y=md=0;
	while(x>=y)
	{ ggi_drawpixel(par->xc+x,par->yc-y);ggi_drawpixel(par->xc-x,par->yc-y);
	  od=md+y+y+1;sd=od-x-x-1;y++;md=od;
	  if (abs(sd)<abs(od)) {x--;md=sd;}
	}
	x=par->rad;y=md=0;
	while(x>=y)
	{ ggi_drawpixel(par->xc-x,par->yc+y);ggi_drawpixel(par->xc+x,par->yc+y);
	  od=md+y+y+1;sd=od-x-x-1;y++;md=od;
	  if (abs(sd)<abs(od)) {x--;md=sd;}
	}
	x=par->rad;y=md=0;
	while(x>=y)
	{ ggi_drawpixel(par->xc+y,par->yc+x);ggi_drawpixel(par->xc-y,par->yc+x);
	  od=md+y+y+1;sd=od-x-x-1;y++;md=od;
	  if (abs(sd)<abs(od)) {x--;md=sd;}
	}

	return(0);
}

int ggi_drawcircle(int xcenter,int ycenter,int radius)
{ 
	switchavail(IO_GRAPH_DRAWCIRCLE,&xcenter);
	setdoemu(IO_GRAPH_DRAWCIRCLE,AVE_ALWAYS,drawcircle_lower,&xcenter);
}
