/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define _LIB_COMPILE_

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include <string.h>
#include "../include/graphlib.h"

#define MAX_EVENT_HANDLERS 30

static void (*EvHandler[MAX_EVENT_HANDLERS])(struct ggi_event);
enum Events EvHandTyp[MAX_EVENT_HANDLERS];
static int handler_count=0;

/*****************************/
/* register an event-handler */
/*****************************/
int ggi_register_evh(int evtype,void (*EvHand)(struct ggi_event))
{ if (handler_count>=MAX_EVENT_HANDLERS) return(-1);
  EvHandler[handler_count]=EvHand;
  EvHandTyp[handler_count]=evtype;
  handler_count++;	/* better we do this really AFTER assigning the values */
  return(0);
}			      

int ggi_send_event(struct ggi_event ev)
{ int x;
  for(x=0;x<handler_count;x++)
  { if (EvHandTyp[x]==EV_ALL||
        EvHandTyp[x]==ev.eventtype) EvHandler[x](ev);
  }
  return(0);
}

