/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define _LIB_COMPILE_

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include <string.h>
#include "../include/graphlib.h"


/*************************************/
/* fill (erase) the (virtual) screen */
/*************************************/

static int fillscreen_lower(int unused,void *unused2)
{ return(ggi_drawbox(0,  0,CurrentMode.virtual.x,CurrentMode.virtual.y)); }

static int fillscreen8bit(int unused,void *unused2)
{ memset(ggi_membuffer,ggi_drwinfo.fg_color,CurrentMode.virtual.x*CurrentMode.virtual.y); 
  return(0);
}

int ggi_fillscreen(void)
{
	switchavail(IO_GRAPH_FILLSCREEN,NULL);

	switcha(IO_GRAPH_FILLSCREEN)
	{ case AVM_MMAP :
		switch(CurrentMode.graphtype)
		{ case GT_8BIT:setdoemu(IO_GRAPH_FILLSCREEN,AVE_MODE,fillscreen8bit,NULL);
  		  default     :break;}
	  case AVM_LOWER:
	  	setdoemu(IO_GRAPH_FILLSCREEN,AVE_ALWAYS,fillscreen_lower,NULL);
	  	break;
	  default       :
	  	ggi_panic("fillscreen - no method.");break;
	}
	return(0);
}
