/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define _LIB_COMPILE_

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include <string.h>
#include "../include/graphlib.h"


/*************************************/
/* request a service from the driver */
/*************************************/
int ggi_ioctl(int cmd,void *parm) 
{ if (ioctl(gd_hand,cmd,parm)) return(-errno);else return(0); }

/*****************************/
/* discard availability info */
/*****************************/
void discard_avail(void)
{ int x;
  for(x=0;x<sizeof(ioctl_avail)/sizeof(ioctl_avail[0]);x++) 
  { ioctl_avail[x]=AVM_IOCTL|AVE_TEST;
    emu_func[x]=ggi_ioctl; }
}

/*****************************************/
/* set the upper-left edge of the screen */
/*****************************************/
int ggi_setviswin(int x,int y)
{ return(ggi_ioctl(IO_CHIP_SETVISWIN,&x)); }

/************************************/
/* set the page of the paged buffer */
/************************************/
int ggi_setpage(int page)
{ return(ggi_ioctl(IO_CHIP_SETPAGE,&page)); }

/*****************************/
/* wait for vertical retrace */
/*****************************/
int ggi_waitvretrace(int page)
{ return(ggi_ioctl(IO_CHIP_WAITVRETRACE,NULL)); }
