/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define _LIB_COMPILE_

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include <string.h>
#include "../include/graphlib.h"


/**********TEMPORARY************/
/* Blit out a 2-color bitfield */
/*******************************/
int ggi_blit2c(int x,int y,int xwidth,int ywidth,void *field)
{ int xp,bp;
  int color;

  for(;ywidth--;y++)
  { for(xp=0,bp=0x80;xp<xwidth;xp++)
    { color=(*(char *)field & bp) ? ggi_drwinfo.fg_color 
    				  : ggi_drwinfo.bg_color;
      ggi_putpixel(x+xp,y,&color);
      if (!(bp>>=1)) {bp=0x80;field++;}
    }
  }
  return(0);
}

/**********TEMPORARY*******/
/* Put a character at x,y */
/**************************/
int ggi_putch(int x,int y,int c)
{ return(ggi_blit2c(x,y,8,16,fontbuf+(c<<5))); }


/****TEMPORARY*******/
/* graphical printf */
/********************/
int ggi_printf(int x,int y,const char *format,...)
{ va_list arg;
  char buffer[1024],*bf;
  int rc;

  va_start(arg,format);bf=buffer;
  rc=vsprintf(buffer,format,arg);
  
  while(*bf)
  { ggi_putch(x,y,*bf++);
    if ((x+=8)>=CurrentMode.virtual.x) {x=0;y+=16;}
  }
  return(rc);
}

