/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define _LIB_COMPILE_

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include <string.h>
#include "../include/graphlib.h"


/*****************************************/
/* get a character from the graphics-tty */
/*****************************************/
int ggi_getch(void)
{ char buffer;
  if (read(ggi_tty_fd,&buffer,1)!=1) return(-1);
  else return(buffer); }

/****************************/
/* is a character available */
/****************************/
int ggi_kbhit(void)
{ fd_set readfds;
  struct timeval timeout;
  FD_ZERO( &readfds );
  FD_SET( ggi_tty_fd, &readfds );
  timeout.tv_sec = timeout.tv_usec = 0;
  return(select( FD_SETSIZE , &readfds, NULL, NULL, &timeout )>0);
}




static struct termios oldtermios;

void setup_kbd(void)
{  struct termios kbdtermios;

   tcgetattr(ggi_tty_fd, &oldtermios);
   kbdtermios=oldtermios;

   kbdtermios.c_lflag = kbdtermios.c_lflag & ~ (ICANON | ECHO);
   kbdtermios.c_cc[VMIN] = 1;
   kbdtermios.c_cc[VTIME] = 0;
   tcsetattr(ggi_tty_fd, TCSAFLUSH, &kbdtermios);
}

void reset_kbd(void)
{ tcsetattr(ggi_tty_fd, TCSAFLUSH, &oldtermios); }
