/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define _LIB_COMPILE_

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include <string.h>
#include "../include/graphlib.h"


/*************************/
/* save a graphics state */
/*************************/
void *ggi_savestate(void)
{ int sz=0;
  void *ptr,*argp;
  argp=&sz;ggi_ioctl(IO_DRIVER_GETSTATESIZE,&argp);
  if (sz==0||(ptr=malloc(sz))==NULL) return NULL;
  argp=&ptr;ggi_ioctl(IO_DRIVER_SAVESTATE,argp);
  return(ptr);
}

/****************************/
/* restore a graphics state */
/****************************/
int ggi_restorestate(void *ptr)
{ return(ggi_ioctl(IO_DRIVER_RESTORESTATE,&ptr)); }

/*****************/
/* save a screen */
/*****************/
void *ggi_savescreen(void)
{ void *ptr;
  if ((ptr=malloc(CurrentMode.virtual.x*CurrentMode.virtual.y))==NULL) return NULL;
  ggi_getbox(0,0,CurrentMode.virtual.x,CurrentMode.virtual.y,ptr);
  return(ptr);
}

/********************/
/* restore a screen */
/********************/
int ggi_restorescreen(void *ptr)
{ return(ggi_putbox(0,0,CurrentMode.virtual.x,CurrentMode.virtual.y,ptr)); }

